property allowedContexts : ""
property deferredTasks : ""
property currentAction : ""

on findAvailActionInContextByID(desiredContextID)
	tell application "OmniFocus"
		tell default document
			set unicodeContextID to desiredContextID as Unicode text
			set thisContext to context id unicodeContextID
			if (thisContext is not missing value) then
				repeat with availTask in available tasks of thisContext
					if deferredTasks does not contain (id of availTask) then
						-- task is available and not in deferred task list
						set foundAction to id of availTask & "@" & name of availTask
						return foundAction
					end if
				end repeat
			end if
		end tell
	end tell
	return ""
end findAvailActionInContextByID

using terms from application "OmniFocus"
	on findAvailActionRecursive(currentContext)
		set foundAction to ""
		if (currentContext is not missing value) then
			repeat with availTask in available tasks of currentContext
				if deferredTasks does not contain (id of availTask) then
					-- task is available and not in deferred task list
					set foundAction to id of availTask & "@" & name of availTask
					return foundAction
				end if
			end repeat
			repeat with childContext in contexts of currentContext
				set foundAction to findAvailActionRecursive(childContext)
				if (foundAction is not "") then
					return foundAction
				end if
			end repeat
		end if
		return foundAction
	end findAvailActionRecursive
end using terms from

on run argv
	set text item delimiters to " "
	set allowedContexts to text items of (item 1 of argv)
	set deferredTasks to item 2 of argv as Unicode text
	if (item 1 of allowedContexts is "") then
		-- use all contexts
		tell application "OmniFocus"
			repeat with thisContext in contexts of default document
				set currentAction to my findAvailActionRecursive(thisContext)
				if (currentAction is not "") then
					exit repeat
				end if
			end repeat
		end tell
	else
		repeat with contextID in allowedContexts
			set currentAction to findAvailActionInContextByID(contextID)
			if (currentAction is not "") then
				exit repeat
			end if
		end repeat
	end if
	return currentAction
end run
